searchData={"items":[{"type":"module","title":"DepsNix","doc":"","ref":"DepsNix.html"},{"type":"function","title":"DepsNix.parse_args/1","doc":"","ref":"DepsNix.html#parse_args/1"},{"type":"function","title":"DepsNix.run/2","doc":"","ref":"DepsNix.html#run/2"},{"type":"type","title":"DepsNix.converger/0","doc":"","ref":"DepsNix.html#t:converger/0"},{"type":"module","title":"DepsNix.Derivation","doc":"","ref":"DepsNix.Derivation.html"},{"type":"function","title":"DepsNix.Derivation.from/1","doc":"","ref":"DepsNix.Derivation.html#from/1"},{"type":"function","title":"DepsNix.Derivation.new/4","doc":"","ref":"DepsNix.Derivation.html#new/4"},{"type":"type","title":"DepsNix.Derivation.t/0","doc":"","ref":"DepsNix.Derivation.html#t:t/0"},{"type":"module","title":"DepsNix.FetchGit","doc":"","ref":"DepsNix.FetchGit.html"},{"type":"type","title":"DepsNix.FetchGit.t/0","doc":"","ref":"DepsNix.FetchGit.html#t:t/0"},{"type":"module","title":"DepsNix.FetchHex","doc":"","ref":"DepsNix.FetchHex.html"},{"type":"type","title":"DepsNix.FetchHex.t/0","doc":"","ref":"DepsNix.FetchHex.html#t:t/0"},{"type":"module","title":"DepsNix.Options","doc":"","ref":"DepsNix.Options.html"},{"type":"type","title":"DepsNix.Options.t/0","doc":"","ref":"DepsNix.Options.html#t:t/0"},{"type":"module","title":"DepsNix.Packages","doc":"","ref":"DepsNix.Packages.html"},{"type":"function","title":"DepsNix.Packages.dependency_names/2","doc":"","ref":"DepsNix.Packages.html#dependency_names/2"},{"type":"function","title":"DepsNix.Packages.filter/2","doc":"","ref":"DepsNix.Packages.html#filter/2"},{"type":"module","title":"DepsNix.Util","doc":"","ref":"DepsNix.Util.html"},{"type":"function","title":"DepsNix.Util.indent/1","doc":"","ref":"DepsNix.Util.html#indent/1"},{"type":"function","title":"DepsNix.Util.indent/2","doc":"","ref":"DepsNix.Util.html#indent/2"},{"type":"task","title":"mix deps.nix","doc":"Creates Nix derivations for Mix dependencies.\n\nWhen run without arguments, generates `deps.nix` in the current directory, but\nonly for `:prod` dependencies.\n\nThe resulting file contains a Nix function that can be called with an empty\nattribute set:\n\n```\npkgs.callPackages ./deps.nix { }\n```\n\nThat attribute set can optionally include overrides, which look like Nix\noverlays:\n\n```\npkgs.callPackages ./deps.nix {\n  overrides = (final: prev: with pkgs.beamPackages; {\n    some_mix_dep = prev.some_mix_dep.override {\n      mixEnv = \"dev\";\n    }\n  };\n}\n```","ref":"Mix.Tasks.Deps.Nix.html"},{"type":"task","title":"Example with all options - mix deps.nix","doc":"This command creates derivations for everything in `:prod`, and only `ex_doc`\nand `credo` in `:dev`. It outputs the Nix expression to `nix/deps.nix`.\n\n```\nmix deps.nix --env prod --env dev=ex_doc,credo --output nix/deps.nix\n```","ref":"Mix.Tasks.Deps.Nix.html#module-example-with-all-options"},{"type":"task","title":"Git dependencies - mix deps.nix","doc":"`deps_nix` supports git dependencies.\n\n`builtins.fetchGit` is used, which doesn't require any prefetching and relies\non the git SHA as a unique identifier.","ref":"Mix.Tasks.Deps.Nix.html#module-git-dependencies"},{"type":"extras","title":"deps_nix","doc":"# deps_nix\n\nA Mix task that converts Mix dependencies to Nix derivations. Inspired by\n[mix2nix](https://github.com/ydlr/mix2nix).\n\nWhile mix2nix is a function of a `mix.lock`, this project instead uses Mix's\ninternals to allow you to choose packages from certain environments. It also\nsupports git dependencies.","ref":"readme.html"},{"type":"extras","title":"Why? - deps_nix","doc":"You want this if you plan to release your Elixir project using nixpkgs' [mixRelease](https://github.com/NixOS/nixpkgs/blob/master/pkgs/development/beam-modules/mix-release.nix), or have other uses for wrapping each of your Mix dependencies in derivations.\n\nUsing separate Nix derivations for each dependency:\n\n- Avoids downloading and compiling all of your dependencies for each release, which is what happens when you use a Fixed-Output Derivation (`mixFodDeps` in `mixRelease`).\n- Lets you cache compiled dependencies and reuse them when they don't change, making your release faster. This is especially important when your dependencies take a while to compile.\n- Gives you loads of geek points.","ref":"readme.html#why"},{"type":"extras","title":"Installation - deps_nix","doc":"```elixir\ndef deps do\n  [\n    {:deps_nix, \"~> 0.0\", only: :dev}\n  ]\nend\n```\n\nOptional: add aliases for `deps.get` and `deps.update`. This helps to keep your\nNix dependencies in sync with what's declared in `mix.exs`:\n\n```elixir\ndef project do\n  [\n    ...\n    aliases: [\n      \"deps.get\": [\"deps.get\", \"deps.nix\"],\n      \"deps.update\": [\"deps.update\", \"deps.nix\"]\n    ]\n  ]\nend\n```\n\nDocs can be found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Usage - deps_nix","doc":"```shell\nmix deps.nix\n```\n\nBy default, this will generate a `deps.nix` file in the current directory,\nusing only the `:prod` dependencies for your project.\n\nSee `mix help deps.nix` for more options.","ref":"readme.html#usage"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,50,46,49]}}